<template>
  <div id="student_lecture_index_wrapper" class="bt-container">
    <div v-if="!loading">
      <i class="el-icon-loading" style="font-size: 50px; float: left"></i>
    </div>
    <div v-else-if="loading && !isOpen">
      <h2 v-if="currentPreviewClass(classId) !== undefined" class="page-title">{{ currentPreviewClass(classId) ? currentPreviewClass(classId).name : '' }}</h2>
      <h2 v-else class="page-title">{{ currentStudyingClass(classId) ? currentStudyingClass(classId).name : '' }}</h2>

      <div class="right-align-margin-bottom-15">
        <!-- <el-button @click="onClick('KNOWLEDGEMAP')">주제지식맵</el-button> -->
        <!-- <el-button @click="onClick('ANALYSIS')">주제저널링</el-button> -->
        <!-- <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('ATTEND')">{{ $t('CLASS_MENU.ATTEND_MANAGE') }}</el-button> -->
        <el-button :class="$attachReactablePostfix('btn-board')" @click="rateDialogVisible=true;">{{ $t('CLASS_MENU.EVALUATION') }}</el-button>
        <el-dialog :title="$t('CLASS_MENU.EVALUATION')" :visible.sync="rateDialogVisible" width="30%">
          <el-rate v-model="rate" allow-half></el-rate>
          <br />
          <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('RATE')">{{ $t('CLASS_MENU.SUBMIT') }}</el-button>
        </el-dialog>
        <!-- <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('ANALYSIS')" >{{ $t('CLASS_MENU.JOURNALING') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('ATTEND')">{{ $t('CLASS_MENU.ATTEND_MANAGE') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('NOTICE')">{{ $t('CLASS_MENU.NOTICE') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('Q&A')">{{ $t('CLASS_MENU.BOARD') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('GRADE')">{{ $t('STUDENT_MENU.VIEW_RESULTS') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('BACK')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button> -->
      </div>

      <lecture-list
        @join="onClickLecture"
        @homework="onClickEstimate"
        @tableColumnColor="tableColumnColor"
        type="STUDENT"
        :list="newLectureList"
      />
      <!-- <lecture-list
        @row-click="onClickLecture"
        @join="onClickJoin"
        @homework="onClickEstimate"
        type="STUDENT"
        :list="lectureL"
      />-->
      <br />
    </div>
    <div v-else-if="loading && isOpen">
      <h2 v-if="currentOpenPreviewClass(classId) !== undefined" class="page-title">{{ currentOpenPreviewClass(classId) ? currentOpenPreviewClass(classId).name : '' }}</h2>
      <div class="right-align-margin-bottom-15">
        <el-button :class="$attachReactablePostfix('btn-board')" @click="rateDialogVisible=true;">{{ $t('CLASS_MENU.EVALUATION') }}</el-button>
        <el-dialog :title="$t('CLASS_MENU.EVALUATION')" :visible.sync="rateDialogVisible" width="30%">
          <el-rate v-model="rate" allow-half></el-rate>
          <br />
          <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('RATE')">{{ $t('CLASS_MENU.SUBMIT') }}</el-button>
        </el-dialog>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('NOTICE')">{{ $t('CLASS_MENU.NOTICE') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('Q&A')">{{ $t('CLASS_MENU.BOARD') }}</el-button>
        <el-button :class="$attachReactablePostfix('btn-board')" @click="onClick('BACK')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </div>
      <lecture-list
        @join="onClickLecture"
        @homework="onClickEstimate"
        @tableColumnColor="tableColumnColor"
        type="STUDENT2"
        :list="lectureL"
      />
    </div>
  </div>
</template>

<script>
import Sortable from "sortablejs";
import { mapState, mapActions, mapGetters, mapMutations } from "vuex";
import studentService from "../../services/studentService";
import classService from "../../services/classService";
import lectureService from "../../services/lectureService";
import LectureList from "../partials/LectureList";
import utils from "../../utils";

const createSortable = (el, options, vnode) => {
  //eslint-disable-line

  let sequence = []; //eslint-disable-line
  return Sortable.create(el, {
    ...options,
    onStart() {
      // when the sort starts, store the initial order of the array
      sequence = this.toArray(); //eslint-disable-line
    },
    onEnd(evt) {
      // when the sort ends, set the order to the initial state
      // change the order using splice
      const data = vnode.context.lectureList;
      data.splice(evt.newIndex, 0, ...data.splice(evt.oldIndex, 1));
    },
  });
};
const sortable = {
  name: "sortable",
};

export default {
  name: "StudentClassShow",
  directives: { sortable },
  components: {
    LectureList,
  },
  data() {
    return {
      lectureL: [],
      loading: false,
      rateDialogVisible: false,
      rate: 0,
      newLectureList: [],
      isOpen: 0,
    };
  },
  async mounted() {
    const vm = this;
    const res = await classService.getClassAffiliation({
      classId: vm.classId
    });
    if (res.data.success) {
      vm.isOpen = res.data.result.affiliation_description.isOpen;
    }

    if (!vm.isOpen) {
      await vm.getMyClassLists();
      await vm.getClass({
        type: "STUDENT",
        classId: vm.classId,
      });
      // 학생이 본인의 수강 강의들 불러오는 부분 mounted에서 동작
      let currentClass = await vm.currentStudyingClass(Number.parseInt(vm.classId, 10));
      let currentClass2 = await vm.currentPreviewClass(Number.parseInt(vm.classId, 10));

      if (currentClass !== undefined && currentClass2 === undefined) {
        if (currentClass && currentClass.lectures) {
          const lecL = currentClass.lectures;
          for (let i = 0; i < lecL.length; i += 1) {
            const item = lecL[i];
            const type = await utils.convertLcType(item.type);
            item.type = type;
            item.capacity = vm.currentStudyingClass(vm.classId).users.length;
            // 수강 완료 - 미완료는 별도의 API 통해 결정
            /* 로그 너무 많이 보내서 삭제 190530
            const res = await lectureService.studentLoginLog({ // eslint-disable-line
              lectureId: item.lecture_id,
            });
            if (res.data.login === true) {
              item.heard = '수강완료';
            } else {
              item.heard = '수강미완료';
            } */
          }
          lecL.forEach(async (index) => {
            if (index.connect_sessions.length !== 0) {
              const accessId = utils.getUserIdFromJwt();
              index.connect_sessions[0].connect_session_permissions.forEach(async (user) => {
                if (index.connect_sessions[0].isActive === 1 && user.user_id === accessId) {
                  await vm.lectureL.push(index);
                }
              });
            } else {
              await vm.lectureL.push(index);
            }
          });

          const lectureStudentNumber = [];

          vm.newLectureList = vm.lectureL.map((list) => ({
            ...list, 
          //   student_number: lectureStudentNumber.find((lecture) => lecture.lecture_id === list.lecture_id).student_number,
          }));

          // [회의방]의 room_id를 가져와서 newLectureList에 추가
          (await Promise.all(vm.newLectureList.map(nll => lectureService.getSmallRoomId({
            lectureId: nll.lecture_id
          })))).map(result => result.data.result ? result.data.result[0] : undefined).forEach((result, index) => {
            if (result) {
              vm.newLectureList[index].room_id = result.room_id;
            }
          });

          vm.showLectureList = true;
          vm.loading = true;
        }
      } else if (currentClass === undefined && currentClass2 !== undefined) {
        const lecL = currentClass2.lectures;
        if (currentClass2 && currentClass2.lectures) {
          for (let i = 0; i < lecL.length; i += 1) {
            const item = lecL[i];
            const type = await utils.convertLcType(item.type);
            item.type = type;
            item.capacity = vm.currentPreviewClass(vm.classId).users.length;
          }
          lecL.forEach(async (index) => {
            if (index.connect_sessions.length !== 0) {
              const accessId = utils.getUserIdFromJwt();
              index.connect_sessions[0].connect_session_permissions.forEach(async (user) => {
                if (index.connect_sessions[0].isActive === 1 && user.user_id === accessId) {
                  await vm.lectureL.push(index);
                }
              });
            } else {
              await vm.lectureL.push(index);
            }
          });

          vm.newLectureList = vm.lectureL.map((list) => ({
            ...list,
          }));
          vm.showLectureList = true;
          vm.loading = true;
        }
      } else {
        vm.lectureL = [];
      }
    } else {
      await vm.getOpenPreviewClass({affiliationId: res.data.result.affiliation_id});
      await vm.getClass2({
        type: "STUDENT",
        classId: vm.classId,
      });
      // 학생이 본인의 수강 강의들 불러오는 부분 mounted에서 동작
      let currentClass = await vm.currentOpenPreviewClass(Number.parseInt(vm.classId, 10));

      if (currentClass && currentClass.lectures) {
        const lecL = currentClass.lectures;
        for (let i = 0; i < lecL.length; i += 1) {
          const item = lecL[i];
          const type = await utils.convertLcType(item.type);
          item.type = type;
        }
        lecL.forEach(async (index) => {
          if (index.connect_sessions.length !== 0) {
            const accessId = utils.getUserIdFromJwt();
            index.connect_sessions[0].connect_session_permissions.forEach(async (user) => {
              if (index.connect_sessions[0].isActive === 1 && user.user_id === accessId) {
                await vm.lectureL.push(index);
              }
            });
          } else {
            await vm.lectureL.push(index);
          }
        });
      }
      vm.loading = true;
    }
  },
  computed: {
    ...mapState("NNclass", ["studyingClassList", "previewClassList", "openPreviewClassList"]),
    ...mapGetters("NNclass", ["currentStudyingClass", "currentPreviewClass", "currentOpenPreviewClass"]),
    ...mapState("studentQuestion", ["lectureHomework"]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    lectureList() {
      const vm = this;
      vm.loading = true;
      return vm.lectureL;
      /*
      return currentClass.lectures.map((item) => {
        const type = utils.convertLcType(item.type);
        // eslint-disable-next-line no-param-reassign
        item.type = type;
        const res = lectureService.studentLoginLog({
          lectureId: item.lecture_id,
        });
        res.then((result) => {
          if (result.data.login === true) {
            item.heard = '수강완료';
          } else {
            item.heard = '수강미완료';
          }
          console.log(item.heard);
        });
        // 수강 완료 or 미완료 기준 변경 -> heartbeat에서 lecture_student_login_logs로
        // eslint-disable-next-line no-param-reassign
        return item;
      }); */
    },
  },
  methods: {
    ...mapActions("NNclass", ["getClass", "getMyClassLists", "getOpenPreviewClass", "getClass2"]),
    ...mapActions("studentQuestion", [
      "updateStudentQuestionMode1",
      "getLectureHomeworkCheck",
    ]),
    ...mapMutations("studentQuestion", ["updateLectureId"]),
    onClick(type) {
      const vm = this;
      switch (type) {
        case "KNOWLEDGEMAP": {
          // TODO : link
          // vm.$router.push(`/a/teacher/class/${vm.classId}/evaluation`);
          break;
        }
        case "ATTEND": {
          const user_id = utils.getUserIdFromJwt();
          vm.$router.push(
            `/a/student/class/${vm.classId}/attendance/${user_id}`
          );
          break;
        }
        case "ANALYSIS": {
          vm.$router.push(`/a/student/class/${vm.classId}/journal`);
          break;
        }
        case "Q&A": {
          vm.$router.push(`/a/class/${vm.classId}/NNboard/0`);
          break;
        }
        case "NOTICE": {
          vm.$router.push(`/a/class/${vm.classId}/NNNotice/0`);
          break;
        }
        case "GRADE": {
          vm.$router.push(`/a/student/class/${vm.classId}/grade`);
          break;
        }
        case "BACK": {
          location.href = "javascript:history.back();";
          break;
        }
        case "RATE": {
          classService.postClassRating({
            classId: vm.classId,
            rating: vm.rate,
          });
          vm.rateDialogVisible = false;
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    tableColumnColor({ row, rowIndex }) {
      const now = Date.now();
      const nowTime = new Date(now);
      if (row.type === '[유인]') {
        return { background: '#F8EFFB' };
      } else {
        if (nowTime < new Date(row.start_time)) {
          return { background: '#FBFBEF' };
        } else if (new Date(row.start_time) <= nowTime && nowTime <= new Date(row.end_time)) {
          return { background: '#EFFBEF' };
        } else {
          return { background: '#EFF5FB' };
        }
      }
    },
    async onClickEstimate(index) {
      const vm = this;
      const lectureId = vm.lectureList[index].lecture_id;
      const classId = vm.lectureList[index].class_id;

      const lhc = studentService.getLectureHomeworkCheck({
        id: lectureId,
      });
      lhc.then(function (res) {
        // eslint-disable-line
        if (res.data.success) {
          const uli = vm.updateLectureId({ lid: lectureId }); // eslint-disable-line
          // 처음 들어갈때 리스트로 초기화
          const usqm = vm.updateStudentQuestionMode1({ mode: 0 }); // eslint-disable-line
          vm.$router.push(
            `/a/student/NNclass/${classId}/quiz?lectureId=${lectureId}`
          );
        } else {
          vm.$notify({
            title: "Info",
            message: vm.$t("NOTIFY.NOT_ACTIV_HOME"),
            type: "info",
            duration: 2000,
          });
        }
      });
    },
    async onClickLecture(index) {
      const vm = this;
      const lectureId = vm.lectureList[index].lecture_id;
      const lectureType = vm.lectureList[index].type;
      const lectureStartTime = Date.parse(vm.lectureList[index].start_time);
      const lectureEndTime = Date.parse(vm.lectureList[index].end_time);
      const classId = vm.classId;
      const currentTime = Date.now();

      // 무인 강의일 경우
      if (lectureType === "[무인]개인") {
        // 강의 활성화 시간 이전에 강의보기를 클릭한 경우
        if (currentTime < lectureStartTime) {
          vm.$notify({
            title: 'Info',
            message: vm.$t('NOTIFY.NOT_ACTIV_CRS'),
            type: 'info',
            duration: 2000,
          });
        // 강의 활성화 시간 이후에 강의보기를 클릭한 경우
        } else if (currentTime > lectureEndTime) {
          vm.$notify({
            title: "Info",
            message: vm.$t("NOTIFY.CLOSED_CRS"),
            type: "info",
            duration: 2000,
          });
        } else {
          vm.$router.push(
            `/a/student/NNlecture/${lectureId}/live?classId=${classId}`
          );
        }
      } else if (lectureType === "[무인]단체") {
        const lectureStartTime2 = lectureStartTime - 300000;

        if (currentTime < lectureStartTime2) {
          vm.$notify({
            title: "Info",
            message: '시작 시간 5분 전부터 입장이 가능합니다.',
            type: "info",
            duration: 2000,
          });
        } else if(currentTime > lectureEndTime) {
          vm.$notify({
            title: 'Info',
            message: vm.$t('NOTIFY.CLOSED_CRS'),
            type: 'info',
            duration: 2000,
          });
        } else {
          vm.$router.push(
            `/a/student/NNlecture/${lectureId}/live?classId=${classId}`
          );
        }
      } else {
        // 유인 강의일 경우
        /* 강사가 접속했는지 is_auto 값 따지기 - 기능 삭제
         *
         * const realTimeLectureInfo = await lectureService.getLecture({
         *   lectureId: vm.lectureList[index].lecture_id,
         * });
         * const realTimeLectureInfo = await lectureService.getLecture({
         *   lectureId: vm.lectureList[index].lecture_id,
         * });
         * if (realTimeLectureInfo.data.is_auto === false) {
         *   // 아직 강사가 접속 안했다면
         *   vm.$notify({
         *     title: 'Info',
         *     message: '아직 열리지 않은 강의입니다. 조금만 기다려주세요.',
         *     type: 'info',
         *     duration: 2000,
         *   });
         *   return;
         * }
         */
        /* 재접속 방지 기능 - 삭제 190319
        const res = await lectureService.studentLoginLog({
          lectureId: vm.lectureList[index].lecture_id,
        });
        if (res.data.login === true) { // 접속 방지
          vm.$notify({
            title: 'Info',
            message: '이미 수강한 강의입니다. 재접속을 원하실 경우 강사에게 문의해주세요.',
            type: 'info',
            duration: 2000,
          });
        } else { } */
        // vm.$router.push(`/a/student/NNlecture/${lectureId}/live`);
        vm.$router.push(
          `/a/student/NNlecture/${lectureId}/live?classId=${classId}`
        );
      }
    },
  },
};
</script>

<style lang="scss" scoped>
#student_lecture_index_wrapper {
  .page-title {
    float: left;
    width: 400px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top: 40px;
    margin-left: 12px;
    margin-bottom: 25px;
  }

  .right-align-margin-bottom-15 {
    float: right;
    display: block;
    text-align: center;
    margin-top: 40px;
    margin-bottom: 25px;
  }

  .right-align {
    text-align: right;
  }
  .center-align {
    text-align: center;
  }
  .right-align-btn {
    width: 100%;
    height: 40px;
    border-radius: 3px;
    border: solid 1px #1989fa;
  }
  .right-align-btn-layer {
    width: 94px;
    height: 12px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
    margin-left: auto;
    margin-right: auto;
  }

  .el-board {
    width: 140px;
    height: 40px;
    border-radius: 3px;
    background-color: #ffffff;
    border: solid 1px #1989fa;

    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #1989fa;
  }

  .el-board:hover {
    width: 140px;
    height: 40px;
    border-radius: 3px;
    background-color: #1989fa;
    border: solid 1px #1989fa;

    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
  }

  .el-btn-phone {
    display: none;
  }

  .right-align-btn-phone {
    display: none;
  }
}
/*
.btn-board-phone {
  display: none;
}
.btn-show-result-phone {
  display: none;
} */
</style>
